/* Sample REXX program loading the REXX forwarder DLL    */
/* for CT_API.DLL and giving an example of how to use it */

call RxFuncAdd "CT_init", "rxct_api", "CT_init"
call RxFuncAdd "CT_data", "rxct_api", "CT_data"
call RxFuncAdd "CT_close", "rxct_api", "CT_close"
call RxFuncAdd "Load_CT_API", "rxct_api", "Load_CT_API"
call RxFuncAdd "Free_CT_API", "rxct_api", "Free_CT_API"

/* ffne Verbindung zum Kartenleser:           */
/*   - Lade "ct_ka.dll",                       */
/* und benutze                                 */
/*   - Logische "Card Terminal Nummer (CTN)"=1 */
/*   - Benutze serielle Schnittstelle 2        */
Load_CT_API(ct_ka)
out = CT_init(1, 2)
/* kurz geht dasselbe auch mit diesem Kommando:*/
/* out = CT_init(ct_ka, 1, 2) */

SAY "CT_init: " out

/* Sende Reset zum Terminal:                   */
/*   - CTN                = 1                  */
/*   - Destination adress = 1 (KartenTerminal) */
/*   - Source adress      = 2 (PC)             */
/*   - Sende-Bytefolge    = 20 10 00 00        */
/*                          (Reset)            */
out = CT_data(1, 1, 2, x2c("20 10 00 00"))
IF LEFT(out,1) = '-' THEN
  SAY "CT_data: " out
ELSE
  SAY "CT_data: " c2x(out)

SAY "Bitte legen Sie eine Krankenversicherungskarte ein: "
PARSE LINEIN pin

/* Sende Reset zur Karte:                      */
/*   - CTN                = 1                  */
/*   - Destination adress = 1 (KartenTerminal) */
/*   - Source adress      = 2 (PC)             */
/*   - Sende-Bytefolge    = 20 10 01 01        */
/*                (Reset mit Anforderung ATR)  */
out = CT_data(1, 1, 2, x2c("20 10 01 01"))
IF LEFT(out,1) = '-' THEN
  SAY "CT_data: " out
ELSE
  SAY "CT_data: " c2x(out)

/* Lese KVK-Karte:                             */
/*   - CTN                = 1                  */
/*   - Destination adress = 0 (Chiparte)       */
/*   - Source adress      = 2 (PC)             */
/*   - Sende-Bytefolge    = 00 b0 00 00 00     */
/*                  (Read binary Kommando)     */
out = CT_data(1, 0, 2, x2c("00 b0 00 00 00"))
SAY "Karte beinhaltet folgende Informationen:"
SAY c2x(out)

SAY "Bitte legen Sie ein Karte mit PIN-Schutz ein: "
PARSE LINEIN pin

/* Sende Reset zur Karte:                      */
/*   - CTN                = 1                  */
/*   - Destination adress = 1 (KartenTerminal) */
/*   - Source adress      = 2 (PC)             */
/*   - Sende-Bytefolge    = 20 10 01 01        */
/*                (Reset mit Anforderung ATR)  */
out = CT_data(1, 1, 2, x2c("20 10 01 01"))
IF LEFT(out,1) = '-' THEN
  SAY "CT_data: " out
ELSE
  SAY "CT_data: " c2x(out)

/* Verifiziere PIN der ISO-Prozessor-Chipkarte */
/*   - CTN                = 1                  */
/*   - Destination adress = 0 (Chipkarte)      */
/*   - Source adress      = 2 (PC)             */
/*   - Sende-Bytefolge    = 00 20 00 00        */
/*                          Pinlnge (z.B. 06) */
/*                          Pin (z.B. "123456")*/
SAY "Bitte geben Sie Ihre PIN ein:"
PARSE PULL pin
out = CT_data(1, 0, 2, x2c("00200000")||d2c(LENGTH(pin))||pin)
IF LEFT(out,1) = '-' THEN
  SAY "CT_data: " out
ELSE
  SAY "CT_data: " c2x(out)

/* Schliee die Verbindung zum Kartenleser:    */
/*   - CTN                = 1                  */
out = CT_close(1)
SAY "CT_close: " out

Free_CT_API()
